import subprocess
import re

# Fichier Org d'origine
fichier_org = "livre.org"
style_css = "style.css"

# Copie du fichier Org
fichier_org_copie = "livre_org_copie.org"

# Expression régulière pour extraire les entêtes des sections
regex_entete = r'\*+ (.*)'
regex_tags = r'(\:.*\:)'
# Expression régulière pour extraire les blocs de commentaires
regex_comment = r'#\+BEGIN\_COMMENT' + r'(.*?)' + r'#\+END\_COMMENT'

print("retraitement du livre avant son export")
def show_lines(content):
    # Compter le nombre de lignes du fichier original
    nb_lignes_origine = len(contenu_org.splitlines())
    print("lignes du livre: ",nb_lignes_origine)

# Créer une copie du fichier Org
with open(fichier_org, "r") as fichier:
    contenu_org = fichier.read()

nb_lignes_origine = len(contenu_org.splitlines())

print("lignes sans modifier le livre orgmode")
show_lines(contenu_org)

    # Supprimer les titres qui ne contiennent pas le tag :title:
contenu_org = re.sub(r"^\*+.*\n", lambda x: x.group() if ":title:" in x.group() else "", contenu_org, flags=re.MULTILINE)

print("lignes sans modifier le livre orgmode")
show_lines(contenu_org)

print("Supprimer les tags des entêtes des sections")
contenu_org = re.sub(regex_tags, '', contenu_org)
# Effacer toutes les occurences de ":title:"
contenu_org = re.sub(r":title:", "", contenu_org)

print("Supprimer les blocs de commentaires")
contenu_org = re.sub(regex_comment, '', contenu_org, flags=re.DOTALL)

# Compter le nombre de lignes du fichier modifié
show_lines(contenu_org)

# Afficher le nombre de lignes supprimées
nb_lignes_modifie = len(contenu_org.splitlines())
nb_lignes_supprimees = nb_lignes_origine - nb_lignes_modifie
print(f"Nombre de lignes supprimées avant l'export de la copie : {nb_lignes_supprimees}")

with open(style_css, "r") as fichier:
    contenu_css = fichier.read()





print('Sauver une copie faite pour la lecture du livre.' , fichier_org_copie)
# Écrire la copie du fichier Org
with open(fichier_org_copie, "w") as fichier:
    fichier.write(contenu_org)

print('Convertir la copie du fichier Org en HTML')
# Convertir la copie du fichier Org en HTML
process = subprocess.run(["pandoc", "livre_org_copie.org", "-o", "livre.html"], capture_output=True, text=True)

# Afficher les messages de console du subprocess
print(process.stdout)
print(process.stderr)


# ouvrir le html et insérer le style css TODO
with open("livre.html", "r") as fichier:
    contenu_html = fichier.read()
contenu_html = re.sub("</head>", "<style type='text/css' >"+contenu_css+"</style></head>", contenu_org)
with open(fichier_org_copie, "w") as fichier:
    fichier.write(contenu_org)

print('Convertir la copie du fichier Org en pdf')
process = subprocess.run(["pandoc", "livre.html", "-o", "livre.pdf"], capture_output=True, text=True)

# Afficher les messages de console du subprocess
print(process.stdout)
print(process.stderr)


print('Convertir la copie du fichier Org en epub')
process = subprocess.run(["pandoc", "livre.html", "-o", "livre.epub"], capture_output=True, text=True)
print(process.stdout)
print(process.stderr)
